/*
 * Copyright 2012 Smallcrew, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package fr.smallcrew.security.web;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.web.authentication.UsernamePasswordAuthenticationFilter;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Controller
@RequestMapping("/login")
public class LoginController {
  @Autowired
  private UsernamePasswordAuthenticationFilter authenticationFilter;

  @RequestMapping(method = RequestMethod.POST)
  public SimpleUser login(HttpServletRequest request, HttpServletResponse response) {
    Authentication authentication = authenticationFilter.attemptAuthentication(request, response);
    authenticationFilter.getRememberMeServices().loginSuccess(request, response, authentication);
    SecurityContextHolder.getContext().setAuthentication(authentication);
    return new SimpleUser(authentication.getName(), authentication.getAuthorities());
  }
}
